SystemOrganization addCategory: #Ani!
SystemOrganization addCategory: #'Ani-Demo-Stack'!
SystemOrganization addCategory: #'Ani-Demo-SolarSystem'!
SystemOrganization addCategory: #'Ani-Demo-Ameba'!
SystemOrganization addCategory: #'Ani-Demo-HansRosling'!
SystemOrganization addCategory: #'Ani-Demo-SubmorphWave'!

Object subclass: #Ani
	instanceVariableNames: 'stepTime'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ani'!

!Ani classSide methodsFor: 'as yet unclassified' stamp: 'hjo 12/14/2011 18:17'!
steppingInstances

	^self allInstances select: [:each| each isStepping].! !

!Ani methodsFor: 'defaults' stamp: 'hjo 12/14/2011 16:23'!
defaultStepTime

	"Return a default object for instance variable stepTime."
	^17! !

!Ani methodsFor: 'stepping' stamp: 'hjo 12/14/2011 18:15'!
isStepping

	^World isStepping: self! !

!Ani methodsFor: 'stepping' stamp: 'hjo 1/28/2012 10:07'!
restartStepping 

	self
		reset;
		startStepping! !

!Ani methodsFor: 'stepping' stamp: 'hjo 12/14/2011 16:15'!
shouldGetStepsFrom: anObject

	^true! !

!Ani methodsFor: 'stepping' stamp: 'hjo 12/14/2011 16:17'!
startStepping 

	World startStepping: self at: Time millisecondClockValue selector: #step arguments: #() stepTime: self stepTime  ! !

!Ani methodsFor: 'stepping' stamp: 'hjo 12/14/2011 16:25'!
step

	self subclassResponsibility! !

!Ani methodsFor: 'accessing' stamp: 'hjo 12/14/2011 16:19'!
stepTime

	^stepTime setDefault: #defaultStepTime for: self withSetter: #stepTime:! !

!Ani methodsFor: 'accessing' stamp: 'hjo 1/11/2012 10:46'!
stepTime: aNumber
	
	| setInstVar |
	setInstVar := [ stepTime := aNumber ].
	self isStepping 
		ifTrue: [
			self stopStepping.
			setInstVar value.
			self startStepping.]
		ifFalse: [ setInstVar value ].
		  
	! !

!Ani methodsFor: 'stepping' stamp: 'hjo 12/14/2011 16:18'!
stopStepping

	World stopStepping: self! !

!Ani methodsFor: 'stepping' stamp: 'hjo 1/4/2012 17:05'!
toggleStepping

	self isStepping
		ifTrue: [ self stopStepping ] 
		ifFalse:  [ self startStepping ] ! !

Ani subclass: #DeterministicAni
	instanceVariableNames: 'duration progress animatedTime finishedOperation timeFunction animationBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ani'!

!DeterministicAni classSide methodsFor: 'instance creation' stamp: 'hjo 12/14/2011 17:38'!
duration: aNumber timeFunctionSelector: aSelector

	| instance |
	instance := self new.
	instance duration: aNumber.  
	instance perform: aSelector.
	^instance! !

!DeterministicAni classSide methodsFor: 'instance creation' stamp: 'hjo 12/14/2011 17:36'!
easeIn: aFloat 

	^self duration: aFloat timeFunctionSelector:  #useEaseInTimeFunction.! !

!DeterministicAni classSide methodsFor: 'instance creation' stamp: 'hjo 12/14/2011 17:36'!
easeInOut: aFloat 

	^self duration: aFloat timeFunctionSelector:  #useEaseInOutTimeFunction.! !

!DeterministicAni classSide methodsFor: 'instance creation' stamp: 'hjo 12/14/2011 17:36'!
easeOut: aFloat 

	^self duration: aFloat timeFunctionSelector:  #useEaseOutTimeFunction.! !

!DeterministicAni classSide methodsFor: 'examples' stamp: 'hjo 12/17/2011 15:29'!
exampleBigBang

	|centerOfUniverse stars universe destinations bigBang |
"setup"
centerOfUniverse := Display center.
stars := 50 timesCollect: [ | s | 
	s := EllipseMorph new.
	s openInWorld.
	s extent: 10@10.
	s color: Color red.
	s borderWidth: 0.  
	s center: Display center.
	].

universe := Display extent.
destinations := stars size timesCollect: [ universe x atRandom  @ universe y atRandom ].

bigBang := DeterministicAni easeOut: 10000.  
bigBang animationBlock: [:pg| 
	stars keysAndValuesDo: [:index :s|  s center: (centerOfUniverse * (1-pg) + ((destinations at: index) * pg )) ] ].

"start ani"
bigBang startStepping.


"clean up"
stars do: [:s| s delete].
bigBang stopStepping.! !

!DeterministicAni classSide methodsFor: 'examples' stamp: 'hjo 1/11/2012 10:47'!
exampleCompareTimeFunctions

|m1 m2 m3 s1 s2 s3 d |

m1 := Morph new.
m2 := Morph new.
m3 := Morph new.
m1 openInWorld.
m2 openInWorld.
m3 openInWorld.
m2 left: m1 right.
m3 left: m2 right.

d := 5000.
s1 := DeterministicAni easeIn: d.
s2 := DeterministicAni easeOut: d.
s3 := DeterministicAni easeInOut: d.

s1 animationBlock: [:p | m1 color: (Color red alpha: p)].
s2 animationBlock: [:p | m2 color: (Color red alpha: p)].
s3 animationBlock: [:p | m3 color: (Color red alpha: p)].

s1 startStepping.
s2 startStepping.
s3 startStepping.

"clean up"
s1 stopStepping.
s2 stopStepping.
s3 stopStepping.

m1 delete.
m2 delete.
m3 delete.! !

!DeterministicAni classSide methodsFor: 'examples' stamp: 'hjo 12/18/2011 21:35'!
exampleDispatch

| morphs dest block m1 a i s t |
morphs := (9 to: 1 by: -1) collect: [:k | |m|
	m := Morph new openInWorld.
	m color: (Color r:0 g:0 b:k/9)
	].  
dest := OrderedCollection new.
dest add:  250@240.
dest add:  300@240.
dest add:  350@240.
dest add:  250@280.
dest add:  300@280.
dest add:  350@280.
dest add:  250@320.
dest add:  300@320.
dest add:  350@320.

i := 1.

block := [m1 := morphs at: i.
s := m1 position.
t := dest at: i.].

block value.

a := DeterministicAni new.
a useEaseInOutTimeFunction.
a duration: 500.  
a animationBlock: [:g| m1 position: t * g + (s*(1-g)) ].
a finishedOperation: 
	[i := i + 1.
	i <= morphs size ifTrue: [
	block value.
	a reset.
	a startStepping.]
	].  
a startStepping.




"cean up"
morphs do: #delete.! !

!DeterministicAni classSide methodsFor: 'examples' stamp: 'hjo 12/14/2011 23:47'!
exampleFinishedOperation

|m1 m2 m3 a12 a23 a31 b|
"preparing"
m1 := Morph new.
m1 openInWorld.
m1 center:  408@68.

m2 := Morph new.
m2 openInWorld.
m2 center:  787@132.

m3 := Morph new. 
m3 openInWorld.
m3 center:  526@252.

b := EllipseMorph new.
b openInWorld.

a12 := DeterministicAni easeOut: 1000.  
a12 animationBlock: [:p| b center: (m1 center * (1-p) + (m2 center * p ))].

a23 := DeterministicAni easeOut: 1000.  
a23 animationBlock: [:p| b center: (m2 center * (1-p) + (m3 center * p ))].

a31 := DeterministicAni easeOut: 1000.  
a31 animationBlock: [:p| b center: (m3 center * (1-p) + (m1 center * p ))].

a12 finishedOperation: [a23 reset; startStepping].  
a23 finishedOperation: [a31 reset; startStepping].  
a31 finishedOperation: [a12 reset;startStepping].  

"initiating the animation"
a12 startStepping.


"clean up"
a12 stopStepping.
a23 stopStepping.
a31 stopStepping.

m1 delete.
m2 delete.
m3 delete.
b delete.
! !

!DeterministicAni classSide methodsFor: 'examples' stamp: 'hjo 12/28/2011 17:49'!
exampleGrouping

|morphs l r p t currentIndex move topMorph|
"creating imagemorphs with screen capture "
morphs := 6 timesCollect:[ Morph new openInWorld color: Color opaqueRandom ].

"where to put it"
l :=   594@500.
r :=   1126@500.
p := (l+r)/2.0.

"place imageMorphs"
morphs do: [:each| 
	each openInWorld.
	each center: p.  
	].
morphs do: #goBehind.  

"imageMorphs do: [:ea| ea extent: 100@100]."

"define animation"
currentIndex := 0.
t := r.
move := DeterministicAni easeOut: 500.  
move animationBlock: [:zp| |u|
	u := (t * (zp)) + (p * (1-zp)).
	u := (0@ (500*(zp-1)*zp)) + u.
	topMorph center: u ].
move finishedOperation:
[	currentIndex := currentIndex+1.
	(currentIndex between: 1 and:  morphs size)
	ifTrue: 
		[
			t := t = r ifTrue: [l] ifFalse: [r].
			topMorph := morphs at: currentIndex.
			topMorph comeToFront. 
			move reset.
			move startStepping].
	].

"start"
move finishedOperation value.


"clean up"
morphs do: #delete.

! !

!DeterministicAni classSide methodsFor: 'examples' stamp: 'hjo 4/13/2012 11:07'!
exampleMoveOverlappingWindows

| windowsAtPoint coveredWin coverWins originalPositions destinationPositions ani reverseAni |

windowsAtPoint := (World morphsAt:Point fromUser) select: [:each| each isKindOf: SystemWindow].

coveredWin := (windowsAtPoint asSortedCollection: (UnarySortDescriptor ascendingBy: [:win| World submorphs indexOf: win ])) first.
  

coverWins := World systemWindows select: [:each|
	each visible and: [ (each bounds intersects: coveredWin bounds) and: [
			(World submorphs indexOf: each)<(World submorphs indexOf: coveredWin) ]  ].
	].

"if coverWinds empty then move coveredWin outside"

originalPositions := Dictionary new.
coverWins do: [:w| originalPositions at: w put: w center ].

destinationPositions := Dictionary new.
coverWins do: [:each| | inter s l |
	inter := each bounds intersect: coveredWin bounds.
	l := (inter width min: inter height)+10.
	s := (each center - coveredWin center) sign.
	destinationPositions at: each put: each center +( (l * s x)@(l * s y)) 
	 ].

ani := DeterministicAni easeInOut: 500.  
ani animationBlock: [:f|
	coverWins do: [:w|
		w center: (((1-f)*(originalPositions at: w)) + (f *(destinationPositions at: w)))
		]
	].  


reverseAni := DeterministicAni easeInOut: 500.  
reverseAni animationBlock: [:f|
	coverWins do: [:w|
		w center: (((f)*(originalPositions at: w)) + ((1-f) *(destinationPositions at: w)))
		]
	].  

ani finishedOperation: [ 
	(Delay forSeconds: 2.0) wait.  
	reverseAni restartStepping ].

ani restartStepping.
! !

!DeterministicAni classSide methodsFor: 'examples' stamp: 'hjo 12/21/2011 10:53'!
exampleSpiral

|c th buds placeThem a b|
"prepare"
c := Display center.
th := 0.
buds := 6 timesCollect: [ |randomFloat|
	randomFloat := [300 atRandom / 300.0].
	Morph new openInWorld color: (Color r: randomFloat value g: randomFloat value b:  randomFloat value) ].
placeThem := [:g| |r|
	r := 300 * g.
	buds keysAndValuesDo: [:k :morph| morph center: (Point r: r degrees: k*360/buds size+th) + c ]].  

a := DeterministicAni easeInOut:  3000.
a animationBlock: [:g| 
	th := 360 * g.
	placeThem value: g ].


b := DeterministicAni easeInOut:  3000.
b animationBlock: [:g| 
	th := 360 * g.
	placeThem value: 1-g] .
a finishedOperation: [b reset; startStepping].  
b finishedOperation: [a reset; startStepping].  

"start"
b startStepping.


"clean up"
a stopStepping.
b stopStepping.
buds do: #delete.! !

!DeterministicAni classSide methodsFor: 'examples' stamp: 'hjo 12/18/2011 20:45'!
exampleWalker

|m1 m2 m3 ms a assignRoles t|
"prepare"
m1 := Morph new.
m1 openInWorld.
m1 color: Color red.  

m2 := Morph new.
m2 openInWorld.
m2 color: Color green.

m3 := Morph new.
m3 openInWorld.
m3 color: Color blue.

ms := OrderedCollection new.
ms add: m1.
ms add: m2.
ms add: m3.

assignRoles := [m1 := ms at: ms size - 1.
m2 := ms at: ms size.
t := m1 left.
m1 comeToFront].

assignRoles value.

a := DeterministicAni new.
a useEaseInOutTimeFunction.
a duration: 1000.  
a animationBlock: [:g| m1 left: m2 right * g + (t*(1-g)) ].
a finishedOperation: [
	ms addFirst: ms removeLast.
	assignRoles value.
	a reset.
	a startStepping.
	].

"start"
a startStepping.

"clean up"
a stopStepping.
ms do: #delete.! !

!DeterministicAni classSide methodsFor: 'examples' stamp: 'hjo 1/28/2012 10:08'!
expose

|originalPositions destinationPositions reverseAni ani|
originalPositions := Dictionary new.
World systemWindows do: [:w| originalPositions at: w put: w center ].

destinationPositions := Dictionary new.
World systemWindows do: [:w| | b bdTop bdBottom bdLeft bdRight shortestDistance |
	b := w bounds.  
	bdTop := (b top - World top) abs.
	bdBottom := (b bottom - World bottom) abs.
	bdLeft := (b left - World left) abs.
	bdRight := (b right - World right) abs.
	shortestDistance := SortedCollection new add: bdTop; add: bdBottom; add: bdLeft; add: bdRight; first.

	shortestDistance = bdTop
		ifTrue: [ destinationPositions at: w put: (w center + (0@(40-b bottom))) ].
	shortestDistance = bdBottom
		ifTrue: [ destinationPositions at: w put: (w center + (0@(World bottom - b top - 40))) ].
	shortestDistance = bdLeft
		ifTrue: [ destinationPositions at: w put: (w center + ((40-b right)@0)) ].
	shortestDistance = bdRight
		ifTrue: [ destinationPositions at: w put: (w center + ((World right- b left - 40)@0)) ].
	 ].

ani := DeterministicAni easeInOut: 500.  
ani animationBlock: [:f|
	World systemWindows do: [:w|
		w center: (((1-f)*(originalPositions at: w)) + (f *(destinationPositions at: w)))
		]
	].  


reverseAni := DeterministicAni easeInOut: 500.  
reverseAni animationBlock: [:f|
	World systemWindows do: [:w|
		w center: (((f)*(originalPositions at: w)) + ((1-f) *(destinationPositions at: w)))
		]
	].  

ani finishedOperation: [ 
	(Delay forSeconds: 2.0) wait.  
	reverseAni restartStepping ].

ani restartStepping.


! !

!DeterministicAni classSide methodsFor: 'examples' stamp: 'hjo 1/13/2012 20:51'!
jumpingMorphs

|m init initPos destPos destColor bounceUp|

m := Morph new.
m openInWorld.

m center: Point fromUser.

init := [
	initPos :=   1115@615.
	m center: initPos.
	destPos := m center + ((200 atRandom-200 atRandom)@ -200). 
	destColor := Color perform: #(red blue green white cyan brown yellow) atRandom].
bounceUp := DeterministicAni new.
bounceUp duration: 600.  
bounceUp useJumpTimeFunction.
init value.
bounceUp animationBlock: [:r| 
	m center:  (initPos*(1-r)) + (destPos*r).
	m color: (Color black*(1-r)) + (destColor*r).
	].
bounceUp finishedOperation: [init value. bounceUp reset startStepping ].  
bounceUp startStepping.  

"clean up"
bounceUp stopStepping.
m delete.! !

!DeterministicAni classSide methodsFor: 'examples' stamp: 'hjo 1/1/2012 16:58'!
sunEarthMoon

|sun earth r orbit moon mr morbit|
sun := CircleMorph new openInWorld.
sun color: Color yellow.

earth := CircleMorph new openInWorld.
earth color: Color blue.
earth extent: sun extent / 2.

r := 100.

orbit := DeterministicAni new.
orbit animationBlock: [:p|
	earth center: (Point r: r degrees:  p * 360) + sun center.
	].
orbit finishedOperation: [orbit reset startStepping]. 
orbit startStepping.


moon := CircleMorph new openInWorld.
moon color: Color gray.
moon extent: earth extent / 2.

mr := 40.

morbit := DeterministicAni new.
morbit animationBlock: [:p|
	moon center: (Point r: mr degrees:  (12*p) * 360) + earth center.
	].
morbit finishedOperation: [morbit reset startStepping]. 
morbit startStepping.


orbit stopStepping.
morbit stopStepping.
sun delete.
earth delete.
moon delete.! !

!DeterministicAni classSide methodsFor: 'examples' stamp: 'hjo 1/23/2012 21:33'!
trembling

|m d b|
m := RectangleMorph new openInWorld.
m bounds: (50@52 extent: 57@57).
m := TransformationMorph new asFlexOf: m.
m openInWorld.

d := DeterministicAni easeInOut: 50.  
d animationBlock: [:r| m rotationDegrees: 14*r.].  

b := DeterministicAni easeInOut: 50.  
b animationBlock: [:r| m rotationDegrees: -14*r.].  

d finishedOperation: [b reset; startStepping].
b finishedOperation: [d reset; startStepping].

d startStepping.

"clean up"
b stopStepping.
d stopStepping.    
m delete.
! !

!DeterministicAni methodsFor: 'accessing' stamp: 'hjo 12/14/2011 16:37'!
animatedTime

	^animatedTime setDefault: #defaultAnimatedTime for: self withSetter: #animatedTime:! !

!DeterministicAni methodsFor: 'accessing' stamp: 'hjo 12/14/2011 16:51'!
animatedTime: aNumber
		
	animatedTime := aNumber! !

!DeterministicAni methodsFor: 'accessing' stamp: 'hjo 12/14/2011 18:30'!
animationBlock

	^animationBlock setDefault: #defaultAnimationBlock for: self withSetter: #animationBlock:! !

!DeterministicAni methodsFor: 'accessing' stamp: 'hjo 12/14/2011 18:30'!
animationBlock: aBlockOf1Arg
		
	animationBlock := aBlockOf1Arg! !

!DeterministicAni methodsFor: 'assertions' stamp: 'hjo 12/14/2011 18:07'!
assertIfDurationIsTooShort

	self assert: [self duration >= self stepTime] description: 'duration is too short compared to stepTime.'! !

!DeterministicAni methodsFor: 'defaults' stamp: 'hjo 12/14/2011 16:37'!
defaultAnimatedTime

	"Return a default object for instance variable animatedTime."
	^0! !

!DeterministicAni methodsFor: 'defaults' stamp: 'hjo 12/14/2011 18:29'!
defaultAnimationBlock

	"Return a default object for instance variable stepBlock."
	^[:prog| Transcript cr; nextPutAll: 'default static animation operation(progress', prog asFloat printString ,')';flush]! !

!DeterministicAni methodsFor: 'defaults' stamp: 'hjo 12/14/2011 16:45'!
defaultDuration

	"milliseconds"
	^2000! !

!DeterministicAni methodsFor: 'defaults' stamp: 'hjo 12/14/2011 16:51'!
defaultFinishedOperation

	"Return a default object for instance variable finishedOperation."
	^[Transcript cr;nextPutAll:'animation finished normally.';flush]! !

!DeterministicAni methodsFor: 'defaults' stamp: 'hjo 12/14/2011 17:06'!
defaultTimeFunction

	"Return a default object for instance variable timeFunction."
	^[:t| t]! !

!DeterministicAni methodsFor: 'accessing' stamp: 'hjo 12/14/2011 16:21'!
duration

	^duration setDefault: #defaultDuration for: self withSetter: #duration:! !

!DeterministicAni methodsFor: 'accessing' stamp: 'hjo 12/14/2011 18:07'!
duration: aNumber
		
	duration := aNumber.
	self assertIfDurationIsTooShort.! !

!DeterministicAni methodsFor: 'accessing' stamp: 'hjo 12/14/2011 16:51'!
finishedOperation

	^finishedOperation setDefault: #defaultFinishedOperation for: self withSetter: #finishedOperation:! !

!DeterministicAni methodsFor: 'accessing' stamp: 'hjo 12/14/2011 16:52'!
finishedOperation: aBlock
		
	finishedOperation := aBlock! !

!DeterministicAni methodsFor: 'accessing' stamp: 'hjo 12/14/2011 16:37'!
progress

	^self animatedTime / self duration  ! !

!DeterministicAni methodsFor: 'stepping' stamp: 'hjo 12/14/2011 18:22'!
reset

	self animatedTime: nil.  ! !

!DeterministicAni methodsFor: 'stepping' stamp: 'hjo 12/17/2011 12:17'!
step

	self progress < 1.0
		ifTrue: [
			self animationBlock value: (self timeFunction value: self progress).
			self animatedTime: self animatedTime + self stepTime  
		]
		ifFalse: [
			self stopStepping.
			self finishedOperation value. 
		]  
	  
	! !

!DeterministicAni methodsFor: 'accessing' stamp: 'hjo 12/14/2011 17:06'!
timeFunction

	^timeFunction setDefault: #defaultTimeFunction for: self withSetter: #timeFunction:! !

!DeterministicAni methodsFor: 'accessing' stamp: 'hjo 12/14/2011 17:43'!
timeFunction: aBlock
		
	timeFunction := aBlock! !

!DeterministicAni methodsFor: 'time functions' stamp: 'hjo 12/14/2011 17:21'!
useEaseInOutTimeFunction

	self timeFunction: [:t| t squared * (3 - (2*t)) ]  ! !

!DeterministicAni methodsFor: 'time functions' stamp: 'hjo 12/14/2011 17:16'!
useEaseInTimeFunction

	self timeFunction: [:t| t squared ]  ! !

!DeterministicAni methodsFor: 'time functions' stamp: 'hjo 12/14/2011 17:17'!
useEaseOutTimeFunction

	self timeFunction: [:t| t sqrt ]  ! !

!DeterministicAni methodsFor: 'time functions' stamp: 'hjo 1/7/2012 10:48'!
useJumpTimeFunction

	self timeFunction: [:t| t * (1-t) * 4.0 ]  ! !

DeterministicAni subclass: #FromToDeterministicAni
	instanceVariableNames: 'destination origination'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ani'!

!FromToDeterministicAni classSide methodsFor: 'examples' stamp: 'hjo 1/3/2012 20:47'!
exampleMorphMove

|m a|
m := Morph new.
m openInWorld.
m color: Color red.

a := FromToDeterministicAni easeInOut: 1000.  
UIManager default inform: 'Click for starting point'.
a origination: Point fromUser.
UIManager default inform: 'Click for ending point'.  
a destination: Point fromUser.
a animationBlock: [:s :o :t :d| 
	m center: (s * o) + (t * d)] .
a startStepping.

"clean up"
a stopStepping.
m delete.! !

!FromToDeterministicAni methodsFor: 'accessing' stamp: 'hjo 12/28/2011 12:52'!
animationBlock: aBlockOf4Arg
		
	self assert: [aBlockOf4Arg numArgs = 4].  
	animationBlock := aBlockOf4Arg! !

!FromToDeterministicAni methodsFor: 'defaults' stamp: 'hjo 12/28/2011 12:36'!
defaultAnimationBlock

	"Return a default object for instance variable stepBlock."
	^[:startRatio :endRatio| 
		Transcript 
			cr; 
			nextPutAll: 'default static animation operation(progress';
			print: startRatio asFloat;
			nextPutAll: ' , ';
			print: endRatio asFloat;
			nextPutAll: ')';
			flush]! !

!FromToDeterministicAni methodsFor: 'defaults' stamp: 'hjo 12/28/2011 12:41'!
defaultDestination

	"Return a default object for instance variable destination."
	^100! !

!FromToDeterministicAni methodsFor: 'defaults' stamp: 'hjo 12/28/2011 12:43'!
defaultOrigination

	"Return a default object for instance variable origination."
	^0! !

!FromToDeterministicAni methodsFor: 'accessing' stamp: 'hjo 12/28/2011 12:41'!
destination

	^destination setDefault: #defaultDestination for: self withSetter: #destination:! !

!FromToDeterministicAni methodsFor: 'accessing' stamp: 'hjo 12/28/2011 12:41'!
destination: anObject
		
	destination := anObject! !

!FromToDeterministicAni methodsFor: 'accessing' stamp: 'hjo 12/28/2011 12:43'!
origination

	^origination setDefault: #defaultOrigination for: self withSetter: #origination:! !

!FromToDeterministicAni methodsFor: 'accessing' stamp: 'hjo 12/28/2011 12:43'!
origination: anObject
		
	origination := anObject! !

!FromToDeterministicAni methodsFor: 'stepping' stamp: 'hjo 12/28/2011 12:52'!
step

	self progress < 1.0
		ifTrue: [ | r |
			r := (self timeFunction value: self progress).
			self animationBlock value:(1-r) value: self origination value: r value: self destination.
			self animatedTime: self animatedTime + self stepTime  
		]
		ifFalse: [
			self stopStepping.
			self finishedOperation value. 
		]  
	  
	! !

Ani subclass: #EndlessAni
	instanceVariableNames: 'operation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ani'!

!EndlessAni methodsFor: 'defaults' stamp: 'hjo 1/2/2012 14:56'!
defaultOperation

	"Return a default object for instance variable operation."
	^[Transcript cr;nextPutAll: 'endless ani is running';flush]! !

!EndlessAni methodsFor: 'accessing' stamp: 'hjo 1/2/2012 14:56'!
operation

	^operation setDefault: #defaultOperation for: self withSetter: #operation:! !

!EndlessAni methodsFor: 'accessing' stamp: 'hjo 1/2/2012 14:56'!
operation: anObject
		
	operation := anObject! !

!EndlessAni methodsFor: 'as yet unclassified' stamp: 'hjo 1/2/2012 14:57'!
step

	self operation value! !

Ani subclass: #GeneralEnvyAni
	instanceVariableNames: 'targetEvaluator currentEvaluator operation stiffness'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ani'!

GeneralEnvyAni subclass: #EnvyAni
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ani'!

!EnvyAni classSide methodsFor: 'examples' stamp: 'hjo 12/17/2011 11:05'!
example2EnvyAndDeterministic

| m1 m2 m3 b e ca sa a12 a23 a31 |
"preparing"
m1 := Morph new.
m1 openInWorld.
m1 center:   101@168.  
m1 color: Color red.

m2 := Morph new.
m2 openInWorld.
m2 center:   494@212.
m2 extent: 100@100.
m2 color: Color green.

m3 := Morph new. 
m3 openInWorld.
m3 center:   332@406.
m3 extent: 20@80.  
m3 color: Color blue.


b := EllipseMorph new.
b openInWorld.
b center: (m1 center + m2 center + m3 center)/3.

e := m1.

sa := EnvyAni new.
sa targetEvaluator: [e extent].
sa currentEvaluator: [b extent].
sa operation: [:v| b extent: v ].
sa stiffness: 0.1.  
sa startStepping.      

ca := EnvyAni new.
ca targetEvaluator: [e color].
ca currentEvaluator: [b color]. 
ca operation: [:v| b color: v].  
ca stiffness: 0.04.  
ca startStepping.

a12 := DeterministicAni easeOut: 1000.  
a12 animationBlock: [:p| b center: (m1 center * (1-p) + (m2 center * p ))].

a23 := DeterministicAni easeOut: 1000.  
a23 animationBlock: [:p| b center: (m2 center * (1-p) + (m3 center * p ))].

a31 := DeterministicAni easeOut: 1000.  
a31 animationBlock: [:p| b center: (m3 center * (1-p) + (m1 center * p ))].

a12 finishedOperation: [a23 reset; startStepping. e:=m3].  
a23 finishedOperation: [a31 reset; startStepping. e:=m1].  
a31 finishedOperation: [a12 reset;startStepping. e:=m2].  

"initiating the animation"
a12 startStepping.


"clean up"
a12 stopStepping.
a23 stopStepping.
a31 stopStepping.
ca stopStepping.
sa stopStepping.

m1 delete.
m2 delete.
m3 delete.
b delete.

! !

!EnvyAni classSide methodsFor: 'examples' stamp: 'hjo 12/17/2011 10:52'!
exampleEnvyAndDeterministic

| m1 m2 m3 b e ca a12 a23 a31 |
"preparing"
m1 := Morph new.
m1 openInWorld.
m1 center:   101@168.
m1 color: Color red.

m2 := Morph new.
m2 openInWorld.
m2 center:   494@212.
m2 color: Color green.

m3 := Morph new. 
m3 openInWorld.
m3 center:   332@406.
m3 color: Color blue.


b := EllipseMorph new.
b openInWorld.
b center: (m1 center + m2 center + m3 center)/3.

e := m1.
ca := EnvyAni new.
ca targetEvaluator: [e color].
ca currentEvaluator: [b color]. 
ca operation: [:v| b color: v].  
ca stiffness: 0.04.  
ca startStepping.
  
a12 := DeterministicAni easeOut: 1000.  
a12 animationBlock: [:p| b center: (m1 center * (1-p) + (m2 center * p ))].

a23 := DeterministicAni easeOut: 1000.  
a23 animationBlock: [:p| b center: (m2 center * (1-p) + (m3 center * p ))].

a31 := DeterministicAni easeOut: 1000.  
a31 animationBlock: [:p| b center: (m3 center * (1-p) + (m1 center * p ))].

a12 finishedOperation: [a23 reset; startStepping. e:=m3].  
a23 finishedOperation: [a31 reset; startStepping. e:=m1].  
a31 finishedOperation: [a12 reset;startStepping. e:=m2].  

"initiating the animation"
a12 startStepping.


"clean up"
a12 stopStepping.
a23 stopStepping.
a31 stopStepping.
ca stopStepping.

m1 delete.
m2 delete.
m3 delete.
b delete.

! !

!EnvyAni classSide methodsFor: 'examples' stamp: 'hjo 1/11/2012 10:58'!
exampleFollowX

|m3 m4 dy|
m3 := Morph new.
m3 openInWorld.
m4 := Morph new.
m4 color: Color green.
m4 openInWorld.

dy := EnvyAni new.
dy startStepping.
dy targetEvaluator: [m3 right].  
dy currentEvaluator: [m4 left].  
dy operation: [:z| m4 left: z].
dy stiffness: 0.1
.

"clean up"
dy stopStepping.
m3 delete.
m4 delete.! !

!EnvyAni methodsFor: 'accessing' stamp: 'hjo 12/14/2011 18:54'!
nexAnimationValue
	^ self targetEvaluator value * self stiffness + (self currentEvaluator value * (1 - self stiffness))! !

!GeneralEnvyAni methodsFor: 'accessing' stamp: 'hjo 12/18/2011 12:13'!
currentEvaluator

	^currentEvaluator setDefault: #defaultCurrentEvaluator for: self withSetter: #currentEvaluator:! !

!GeneralEnvyAni methodsFor: 'accessing' stamp: 'hjo 12/18/2011 12:14'!
currentEvaluator: aBlock
		
	self assert: [aBlock argumentCount = 0].
	currentEvaluator := aBlock! !

!GeneralEnvyAni methodsFor: 'defaults' stamp: 'hjo 12/18/2011 12:14'!
defaultCurrentEvaluator

	"Return a default object for instance variable currentEvaluator."
	^[6]! !

!GeneralEnvyAni methodsFor: 'defaults' stamp: 'hjo 12/18/2011 12:18'!
defaultOperation

	"Return a default object for instance variable operation."
	^[:newCurrent| "do something with newCurrent" ]! !

!GeneralEnvyAni methodsFor: 'defaults' stamp: 'hjo 12/18/2011 12:18'!
defaultStiffness

	"Return a default object for instance variable factor."
	^0.04! !

!GeneralEnvyAni methodsFor: 'defaults' stamp: 'hjo 12/18/2011 12:19'!
defaultTargetEvaluator

	"Return a default object for instance variable targetEvaluator."
	^[7]! !

!GeneralEnvyAni methodsFor: 'accessing' stamp: 'hjo 12/18/2011 12:23'!
nexAnimationValue

	"answer an object that will be passed to animation block operation"
	^self subclassResponsibility! !

!GeneralEnvyAni methodsFor: 'accessing' stamp: 'hjo 12/18/2011 12:19'!
operation

	^operation setDefault: #defaultOperation for: self withSetter: #operation:! !

!GeneralEnvyAni methodsFor: 'accessing' stamp: 'hjo 1/14/2012 09:48'!
operation: aBlock
		
	self assert: [aBlock isNil or: [aBlock argumentCount = 1]].
	operation := aBlock! !

!GeneralEnvyAni methodsFor: 'as yet unclassified' stamp: 'hjo 12/18/2011 15:42'!
rollModel: object1 follower: object2 aspect: aSymbol

	| setter |
	setter := (aSymbol , ':') asSymbol.
	self targetEvaluator: [object1 perform: aSymbol ].  
	self currentEvaluator: [object2 perform: aSymbol ].
	self operation: [:v| object2 perform: setter with: v].! !

!GeneralEnvyAni methodsFor: 'accessing' stamp: 'hjo 12/18/2011 12:20'!
step

	self operation value: self nexAnimationValue! !

!GeneralEnvyAni methodsFor: 'accessing' stamp: 'hjo 12/18/2011 12:21'!
stiffness

	^stiffness setDefault: #defaultStiffness for: self withSetter: #stiffness:! !

!GeneralEnvyAni methodsFor: 'accessing' stamp: 'hjo 12/18/2011 12:21'!
stiffness: aNumber
		
	self assert: [aNumber between: 0 and: 1 ].
	stiffness := aNumber! !

!GeneralEnvyAni methodsFor: 'accessing' stamp: 'hjo 12/18/2011 12:22'!
targetEvaluator

	^targetEvaluator setDefault: #defaultTargetEvaluator for: self withSetter: #targetEvaluator:! !

!GeneralEnvyAni methodsFor: 'accessing' stamp: 'hjo 12/18/2011 12:22'!
targetEvaluator: aBlock

	self assert: [aBlock argumentCount = 0].		
	targetEvaluator := aBlock! !

GeneralEnvyAni subclass: #InertialEnvyAni
	instanceVariableNames: 'friction inertia'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ani'!

!InertialEnvyAni classSide methodsFor: 'examples' stamp: 'hjo 1/13/2012 20:43'!
exampleFollowX

| m3 m4 dy |


"prepare"
m3 := Morph new.
m3 openInWorld.

m4 := Morph new.
m4 color: Color green.
m4 openInWorld.

dy := InertialEnvyAni new.
dy inertia: 0.  
dy friction: 0.9.  
dy targetEvaluator: [m3 right].  
dy currentEvaluator: [m4 left].  
dy operation: [:z| m4 left: z].
dy stiffness: 0.1.

"start"
dy startStepping..

"clean up"
dy stopStepping.
m3 delete.
m4 delete.! !

!InertialEnvyAni classSide methodsFor: 'examples' stamp: 'hjo 1/13/2012 20:43'!
exampleInspectorFollowingBrowser

|iw bw dy systemWindowsBefore|
"prepare"
iw := Inspector openOn: Morph new.
systemWindowsBefore := World systemWindows.
OBSystemBrowser openOnClass: iw model object class.
bw := (World systemWindows copyWithoutAll: systemWindowsBefore) anyOne. 

dy := InertialEnvyAni new.
dy inertia: 0.  
dy friction: 0.9.  
dy targetEvaluator: [iw topRight].  
dy currentEvaluator: [bw topLeft].  
dy operation: [:z| bw topLeft: z].
dy stiffness: 0.1.

"start"
dy startStepping.

"clean up"
dy stopStepping.
iw delete.
bw delete.! !

!InertialEnvyAni classSide methodsFor: 'examples' stamp: 'hjo 1/13/2012 20:42'!
exampleZiniDasWuslon

| nodeMaker ziniDasWuslon animations head headAni setNextGoal origin destination tailMaker |


"setup"
nodeMaker := [|node| 
	node := EllipseMorph new.
	node openInWorld.
	node extent: 50@50.
	node color: Color yellow.
	node borderWidth: 0.
].

ziniDasWuslon := OrderedCollection new.
animations := OrderedCollection new.

head := nodeMaker value.
ziniDasWuslon add: head.

headAni := DeterministicAni easeInOut: 500.  
setNextGoal := 
	[origin := head center.
	destination := Sensor cursorPoint + (200 atRandom @ 200 atRandom) - (200 atRandom @ 200 atRandom).].
setNextGoal value.
headAni animationBlock: [:pg |  head center: (origin * (1-pg) + (destination * pg )) ].  
headAni finishedOperation: [ 
	setNextGoal value. 
	headAni reset. 
	headAni startStepping. ].  
animations add: headAni.
headAni startStepping.

tailMaker := [
	|target follower followingAni |
	target := ziniDasWuslon last.
	follower := nodeMaker value.
	follower color: target color darker.
	followingAni := InertialEnvyAni new.
	followingAni rollModel: target follower: follower aspect: #center.
	followingAni inertia: 0@0.  
	followingAni startStepping.    
	ziniDasWuslon add: follower.
	animations add: followingAni
	].

tailMaker value. "evaluate as much as you want"

ziniDasWuslon do: #goBehind. "change z order to look correctly"
ziniDasWuslon reverseDo: #comeToFront. "change z order to look correctly"


"clean up"
animations do: #stopStepping.
ziniDasWuslon do: #delete.
! !

!InertialEnvyAni methodsFor: 'defaults' stamp: 'hjo 12/18/2011 11:10'!
defaultFriction

	"Return a default object for instance variable friction."
	^0.7! !

!InertialEnvyAni methodsFor: 'defaults' stamp: 'hjo 1/13/2012 20:34'!
defaultInertia

	"Return a default object for instance variable inertia."
	^0! !

!InertialEnvyAni methodsFor: 'accessing' stamp: 'hjo 12/18/2011 11:10'!
friction

	^friction setDefault: #defaultFriction for: self withSetter: #friction:! !

!InertialEnvyAni methodsFor: 'accessing' stamp: 'hjo 12/18/2011 20:16'!
friction: aNumber
		
	friction := aNumber! !

!InertialEnvyAni methodsFor: 'accessing' stamp: 'hjo 1/13/2012 20:34'!
inertia

	^inertia setDefault: #defaultInertia for: self withSetter: #inertia:! !

!InertialEnvyAni methodsFor: 'accessing' stamp: 'hjo 1/13/2012 20:34'!
inertia: anObject
		
	inertia := anObject! !

!InertialEnvyAni methodsFor: 'accessing' stamp: 'hjo 1/13/2012 20:40'!
nexAnimationValue
	
	| curr |
	curr := self currentEvaluator value.
	self inertia: self inertia * self friction.
	self inertia: (self targetEvaluator value - curr) * self stiffness + self inertia.
	^curr + self inertia! !

Object subclass: #LinearInterpolation
	instanceVariableNames: 'valueForZero valueForOne'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ani'!

!LinearInterpolation methodsFor: 'defaults' stamp: 'hjo 12/28/2011 18:16'!
defaultValueForOne

	"Return a default object for instance variable valueForOne."
	^20! !

!LinearInterpolation methodsFor: 'defaults' stamp: 'hjo 12/28/2011 18:15'!
defaultValueForZero

	"Return a default object for instance variable valueForZero."
	^-10! !

!LinearInterpolation methodsFor: 'as yet unclassified' stamp: 'hjo 12/28/2011 18:22'!
forArray: anArray do: aBlockClosure 

	anArray keysAndValuesDo: [:index :object| 
		aBlockClosure value: (self value: index/anArray size) value: object
		]  ! !

!LinearInterpolation methodsFor: 'as yet unclassified' stamp: 'hjo 12/28/2011 18:18'!
value: aNumber

	^(self valueForOne * aNumber) + (self valueForZero * (1-aNumber))! !

!LinearInterpolation methodsFor: 'accessing' stamp: 'hjo 12/28/2011 18:16'!
valueForOne

	^valueForOne setDefault: #defaultValueForOne for: self withSetter: #valueForOne:! !

!LinearInterpolation methodsFor: 'accessing' stamp: 'hjo 12/28/2011 18:16'!
valueForOne: anObject
		
	valueForOne := anObject! !

!LinearInterpolation methodsFor: 'accessing' stamp: 'hjo 12/28/2011 18:15'!
valueForZero

	^valueForZero setDefault: #defaultValueForZero for: self withSetter: #valueForZero:! !

!LinearInterpolation methodsFor: 'accessing' stamp: 'hjo 12/28/2011 18:15'!
valueForZero: anObject
		
	valueForZero := anObject! !

Object subclass: #SolarSystem
	instanceVariableNames: 'sun earth ani moon mercury venus mars jupiter bodiesToAnimate'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ani-Demo-SolarSystem'!

!SolarSystem commentStamp: 'hjo 1/1/2012 21:27' prior: 0!
http://screencast.com/t/gvYjwYo8T5ne!

!SolarSystem classSide methodsFor: 'examples' stamp: 'hjo 1/11/2012 11:10'!
example

|ss|
"create one by one"
ss := SolarSystem new.
ss addEarth.
ss startStepping.
ss addMoon.
ss addMercury.
ss addVenus.
ss addMars.
ss addJupiter.

"clean up"
ss vanish.! !

!SolarSystem methodsFor: 'as yet unclassified' stamp: 'hjo 1/1/2012 21:16'!
addEarth

	self bodiesToAnimate add: self earth! !

!SolarSystem methodsFor: 'as yet unclassified' stamp: 'hjo 1/1/2012 21:17'!
addJupiter

	self bodiesToAnimate add: self jupiter! !

!SolarSystem methodsFor: 'as yet unclassified' stamp: 'hjo 1/1/2012 21:17'!
addMars

	self bodiesToAnimate add: self mars! !

!SolarSystem methodsFor: 'as yet unclassified' stamp: 'hjo 1/1/2012 21:15'!
addMercury

	self bodiesToAnimate add: self mercury! !

!SolarSystem methodsFor: 'as yet unclassified' stamp: 'hjo 1/1/2012 21:16'!
addMoon

	self bodiesToAnimate add: self moon! !

!SolarSystem methodsFor: 'as yet unclassified' stamp: 'hjo 1/1/2012 21:16'!
addVenus

	self bodiesToAnimate add: self venus! !

!SolarSystem methodsFor: 'accessing' stamp: 'hjo 1/1/2012 20:34'!
ani

	^ani setDefault: #defaultAni for: self withSetter: #ani:! !

!SolarSystem methodsFor: 'accessing' stamp: 'hjo 1/1/2012 20:34'!
ani: anObject
		
	ani := anObject! !

!SolarSystem methodsFor: 'accessing' stamp: 'hjo 1/1/2012 21:14'!
bodiesToAnimate

	^bodiesToAnimate setDefault: #defaultBodiesToAnimate for: self withSetter: #bodiesToAnimate:! !

!SolarSystem methodsFor: 'accessing' stamp: 'hjo 1/1/2012 21:14'!
bodiesToAnimate: anObject
		
	bodiesToAnimate := anObject! !

!SolarSystem methodsFor: 'defaults' stamp: 'hjo 1/2/2012 15:01'!
defaultAni

	"Return a default object for instance variable ani."
	^EndlessAni new
		stepTime: 50;  
		operation: [ self bodiesToAnimate do: #followOrbit	 ].! !

!SolarSystem methodsFor: 'defaults' stamp: 'hjo 1/1/2012 21:14'!
defaultBodiesToAnimate

	"Return a default object for instance variable bodiesToAnimate."
	^Set new! !

!SolarSystem methodsFor: 'defaults' stamp: 'hjo 1/1/2012 21:08'!
defaultEarth

	"Return a default object for instance variable earth."
	^HeavenlyBodyMorph new 
		openInWorld 
		color: Color blue;
		extent: self sun extent /2;
		orbitCenterMorph: self sun;
		angularVelocity:1; 
		apsis: 200! !

!SolarSystem methodsFor: 'defaults' stamp: 'hjo 1/1/2012 21:03'!
defaultJupiter

	"Return a default object for instance variable mars."
	^HeavenlyBodyMorph new openInWorld
		angularVelocity:   1/11.8618;
		orbitCenterMorph: self sun;  
		extent: (self earth extent + self sun extent)/2;
		apsis: 350;  
		color: Color orange
! !

!SolarSystem methodsFor: 'defaults' stamp: 'hjo 1/1/2012 20:59'!
defaultMars

	"Return a default object for instance variable mars."
	^HeavenlyBodyMorph new openInWorld
		 extent: self earth extent *0.8;
		 color: Color red;
		 orbitCenterMorph: self sun; 
		 angularVelocity:  0.5313179158945575;
		 apsis: 300.  
! !

!SolarSystem methodsFor: 'defaults' stamp: 'hjo 1/1/2012 21:20'!
defaultMercury

	"Return a default object for instance variable mercury."
	^HeavenlyBodyMorph new openInWorld
		extent: self moon extent;
		color: Color gray;
		orbitCenterMorph: sun;
		angularVelocity:  4.152030758243857.
! !

!SolarSystem methodsFor: 'defaults' stamp: 'hjo 1/1/2012 20:42'!
defaultMoon

	"Return a default object for instance variable moon."
	
	^HeavenlyBodyMorph new openInWorld
		extent: self earth extent /2;
		color: Color gray;
		orbitCenterMorph: self earth;
		angularVelocity: 12.  ! !

!SolarSystem methodsFor: 'defaults' stamp: 'hjo 1/1/2012 20:51'!
defaultSun

	"Return a default object for instance variable sun."
	^CircleMorph new openInWorld
		color: Color yellow;
		center: Display center! !

!SolarSystem methodsFor: 'defaults' stamp: 'hjo 1/1/2012 21:11'!
defaultVenus

	"Return a default object for instance variable venus."
	^HeavenlyBodyMorph new openInWorld
		color: Color red;
		extent: self earth extent;  
		angularVelocity:  1.6254955729628071;  
		orbitCenterMorph: self sun;  
		apsis:100.
! !

!SolarSystem methodsFor: 'accessing' stamp: 'hjo 1/1/2012 20:32'!
earth

	^earth setDefault: #defaultEarth for: self withSetter: #earth:! !

!SolarSystem methodsFor: 'accessing' stamp: 'hjo 1/1/2012 20:32'!
earth: anObject
		
	earth := anObject! !

!SolarSystem methodsFor: 'accessing' stamp: 'hjo 1/1/2012 20:56'!
jupiter

	^jupiter setDefault: #defaultJupiter for: self withSetter: #jupiter:! !

!SolarSystem methodsFor: 'accessing' stamp: 'hjo 1/1/2012 20:56'!
jupiter: anObject
		
	jupiter := anObject! !

!SolarSystem methodsFor: 'accessing' stamp: 'hjo 1/1/2012 20:51'!
mars

	^mars setDefault: #defaultMars for: self withSetter: #mars:! !

!SolarSystem methodsFor: 'accessing' stamp: 'hjo 1/1/2012 20:51'!
mars: anObject
		
	mars := anObject! !

!SolarSystem methodsFor: 'accessing' stamp: 'hjo 1/1/2012 20:44'!
mercury

	^mercury setDefault: #defaultMercury for: self withSetter: #mercury:! !

!SolarSystem methodsFor: 'accessing' stamp: 'hjo 1/1/2012 20:44'!
mercury: anObject
		
	mercury := anObject! !

!SolarSystem methodsFor: 'accessing' stamp: 'hjo 1/1/2012 20:41'!
moon

	^moon setDefault: #defaultMoon for: self withSetter: #moon:! !

!SolarSystem methodsFor: 'accessing' stamp: 'hjo 1/1/2012 20:41'!
moon: anObject
		
	moon := anObject! !

!SolarSystem methodsFor: 'as yet unclassified' stamp: 'hjo 1/11/2012 11:07'!
startStepping

	self ani startStepping.! !

!SolarSystem methodsFor: 'accessing' stamp: 'hjo 1/1/2012 17:55'!
sun

	^sun setDefault: #defaultSun for: self withSetter: #sun:! !

!SolarSystem methodsFor: 'accessing' stamp: 'hjo 1/1/2012 17:55'!
sun: anObject
		
	sun := anObject! !

!SolarSystem methodsFor: 'as yet unclassified' stamp: 'hjo 1/1/2012 21:19'!
vanish

	self ani stopStepping.
	self bodiesToAnimate do: #delete.
	self sun delete! !

!SolarSystem methodsFor: 'accessing' stamp: 'hjo 1/1/2012 20:46'!
venus

	^venus setDefault: #defaultVenus for: self withSetter: #venus:! !

!SolarSystem methodsFor: 'accessing' stamp: 'hjo 1/1/2012 20:46'!
venus: anObject
		
	venus := anObject! !

Object subclass: #SubmorphWave
	instanceVariableNames: 'mainMorph units random'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ani-Demo-SubmorphWave'!

!SubmorphWave methodsFor: 'as yet unclassified' stamp: 'hjo 1/14/2012 16:14'!
anis

	^self units collect: #followingAni  ! !

!SubmorphWave methodsFor: 'as yet unclassified' stamp: 'hjo 1/14/2012 16:13'!
children 

	^self units collect: #morph  ! !

!SubmorphWave methodsFor: 'operations' stamp: 'hjo 1/14/2012 16:11'!
cleanUp

self anis do: #stopStepping.
self children do: #delete.
mainMorph delete.
mainMorph := nil.
! !

!SubmorphWave methodsFor: 'defaults' stamp: 'hjo 1/14/2012 16:52'!
defaultRandom

	"Return a default object for instance variable random."
	^Random new! !

!SubmorphWave methodsFor: 'defaults' stamp: 'hjo 1/14/2012 16:13'!
defaultUnits

	"Return a default object for instance variable units."
	^OrderedCollection new! !

!SubmorphWave methodsFor: 'as yet unclassified' stamp: 'hjo 1/14/2012 15:53'!
mainMorph

	^mainMorph! !

!SubmorphWave methodsFor: 'as yet unclassified' stamp: 'hjo 1/14/2012 15:57'!
mainMorph: aMorph

	self assert: [mainMorph isNil].
	mainMorph := aMorph! !

!SubmorphWave methodsFor: 'operations' stamp: 'hjo 1/14/2012 17:23'!
moveMainMorphFromUser

mainMorph center: Point fromUser.! !

!SubmorphWave methodsFor: 'accessing' stamp: 'hjo 1/14/2012 16:52'!
random

	^random setDefault: #defaultRandom for: self withSetter: #random:! !

!SubmorphWave methodsFor: 'accessing' stamp: 'hjo 1/14/2012 16:52'!
random: anObject
		
	random := anObject! !

!SubmorphWave methodsFor: 'operations' stamp: 'hjo 1/14/2012 17:25'!
setUpMainMorphFromUser

| aMorph |
aMorph := World submorphsInRectagleFromUser anyOne.
self mainMorph: aMorph.
self tearOutAndAnimateSubmorphsOf: aMorph.  ! !

!SubmorphWave methodsFor: 'as yet unclassified' stamp: 'hjo 1/14/2012 17:21'!
tearOutAndAnimateSubmorphsOf: aMorph

|subs|
subs := aMorph submorphs copy.
subs do: [:sm| | unit |
	"subs do: [:each| self tearOutAndAnimateSubmorphsOf: each]."
	unit := SwUnit new
		morph: sm;
		ownerMorph: aMorph;
		centerOffset: (sm untruncatedCenter - aMorph untruncatedCenter).
	unit followingAni friction: 0.7 + (self random next * 0.1).
	unit followingAni startStepping.
	self units add: unit.
	
	aMorph removeMorph: sm.
	sm openInWorld.
	].
! !

!SubmorphWave methodsFor: 'accessing' stamp: 'hjo 1/14/2012 16:13'!
units

	^units setDefault: #defaultUnits for: self withSetter: #units:! !

!SubmorphWave methodsFor: 'accessing' stamp: 'hjo 1/14/2012 16:13'!
units: anObject
		
	units := anObject! !

Object subclass: #SwUnit
	instanceVariableNames: 'morph morphOwner centerOffset followingAni ownerMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ani-Demo-SubmorphWave'!

!SwUnit methodsFor: 'accessing' stamp: 'hjo 1/14/2012 15:32'!
centerOffset
	^ centerOffset! !

!SwUnit methodsFor: 'accessing' stamp: 'hjo 1/14/2012 15:32'!
centerOffset: anObject
	centerOffset := anObject! !

!SwUnit methodsFor: 'defaults' stamp: 'hjo 1/14/2012 17:10'!
defaultFollowingAni

	"Return a default object for instance variable followingAni."
	^InertialEnvyAni new
		inertia: 0@0;
		stiffness: 0.2;
		targetEvaluator: [ ownerMorph untruncatedCenter + self centerOffset ];
		currentEvaluator: [self morph untruncatedCenter];
		operation: [:p| 
			(self morph owner) addMorph: (self morph) inFrontOf: ownerMorph.
			(self morph) untruncatedCenter: p].  
! !

!SwUnit methodsFor: 'accessing' stamp: 'hjo 1/14/2012 15:35'!
followingAni

	^followingAni setDefault: #defaultFollowingAni for: self withSetter: #followingAni:! !

!SwUnit methodsFor: 'accessing' stamp: 'hjo 1/14/2012 15:35'!
followingAni: anObject
		
	followingAni := anObject! !

!SwUnit methodsFor: 'accessing' stamp: 'hjo 1/14/2012 15:31'!
morph

	^morph! !

!SwUnit methodsFor: 'accessing' stamp: 'hjo 1/14/2012 15:30'!
morph: anObject
		
	morph := anObject! !

!SwUnit methodsFor: 'accessing' stamp: 'hjo 1/14/2012 15:32'!
morphOwner
	^ morphOwner! !

!SwUnit methodsFor: 'accessing' stamp: 'hjo 1/14/2012 15:32'!
morphOwner: anObject
	morphOwner := anObject! !

!SwUnit methodsFor: 'as yet unclassified' stamp: 'hjo 1/14/2012 17:07'!
ownerMorph: aMorph

	ownerMorph := aMorph! !

EllipseMorph subclass: #AnimatedEllipseMorph
	instanceVariableNames: 'stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ani-Demo-HansRosling'!

!AnimatedEllipseMorph commentStamp: 'hjo 2/6/2009 16:55' prior: 0!
Mimiced presentation of HansRosling 2006 TED.!

!AnimatedEllipseMorph classSide methodsFor: 'examples' stamp: 'hjo 2/6/2009 16:54'!
howToUseInWorkspace

"Create morphs"
| m1 m2 m3 m4 m5 m6 |
m1 := AnimatedEllipseMorph openInWorldRadius: 40 color: Color green.
m2 := AnimatedEllipseMorph openInWorldRadius: 20 color: Color red.
m3 := AnimatedEllipseMorph openInWorldRadius: 20 color: Color red darker darker.
m4 := AnimatedEllipseMorph openInWorldRadius: 10 color: Color blue.
m5 := AnimatedEllipseMorph openInWorldRadius: 10 color: Color blue.
m6 := AnimatedEllipseMorph openInWorldRadius: 10 color: Color blue.


"Start animation"
m1 setStream: #( (40 40) (100 80) (140 90) (90 130) (60 160) (40 240) (150 200) (170 170) ( 143 94) ( 230 58) ( 250 137) ( 95 158) ( 227 275) ( 274 174)).

m2 setStream: #( (40 50) (110 90) (100 90) (90 110) (30 160) (80 240) (190 230) (150 270) ( 113 114) ( 220 38) ( 200 197) ( 125 170) ( 217 265) ( 290 124)).

m3 setStream: #( (40 60) (100 95) (110 75) (95 105) (40 180) (70 200) (170 220) (130 210) ( 123 124) ( 210 68) ( 230 157) ( 115 160) ( 207 255) ( 280 144)).

m4 setStream: #( (50 60) (120 105) (120 80) (75 120) (50 170) (77 211) (181 210) (140 250) ( 100 140) ( 260 98) ( 240 200) ( 105 150) ( 200 245) ( 290 154)).

m5 setStream:  #((15 28) (83 82) (69 45) (31 86) (10 137) (32 177) (133 189) (109 220) (60 118) (201 68) (186 163) (48 122) (170 222) (259 133)).

m6 setStream:   #((16 35) (90 76) (85 59) (26 89) (17 145) (25 172) (150 189) (104 227) (45 106) (207 73) (209 162) (65 113) (157 218) (240 132)).


"Delete all morphs"
AnimatedEllipseMorph allInstances do: [:each| each delete].


! !

!AnimatedEllipseMorph classSide methodsFor: 'instance creation' stamp: 'hjo 2/5/2009 02:27'!
openInWorldRadius: anInteger color: aColor
	
	| m |
	m := self new.
	m extent: anInteger asPoint.
	m color: aColor.
	^m openInWorld.! !

!AnimatedEllipseMorph methodsFor: 'as yet unclassified' stamp: 'hjo 2/5/2009 01:57'!
setStream: anArray

	| milePoint endPoint startPoint |
	milePoint := (anArray collect: [:each| each first @ each second ]) readStream.
	stream := ReadWriteStream on: Array new.
	endPoint := milePoint next.
	
	[milePoint atEnd] whileFalse: 
		[
			startPoint := endPoint.
			endPoint := milePoint next.
			(0.0 to: 1.0 by: 0.07) do: [:r | stream nextPut: (startPoint * (1-r)) + (endPoint * r) ].
		].
	
	stream reset.
	
	self center: stream next.! !

!AnimatedEllipseMorph methodsFor: 'as yet unclassified' stamp: 'hjo 2/5/2009 01:58'!
step

	stream isNil ifTrue: [^self].
	stream atEnd ifTrue: [^self].
	self center: stream next.
! !

!AnimatedEllipseMorph methodsFor: 'as yet unclassified' stamp: 'hjo 2/5/2009 01:53'!
stepTime

	^17! !

Morph subclass: #AbstractStackMorph
	instanceVariableNames: 'morphAbove'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ani-Demo-Stack'!

!AbstractStackMorph methodsFor: 'initialization' stamp: 'hjo 12/29/2011 10:21'!
initialize 

	super initialize.
	self extent: 150@100.
	self color: Color opaqueRandom! !

!AbstractStackMorph methodsFor: 'operations' stamp: 'hjo 12/29/2011 10:20'!
makeNewOneThatSitsOnMe

	|m|
	m := StackingMorph new.
	m openInWorld.
	m sitOn: self.  ! !

!AbstractStackMorph methodsFor: 'accessing' stamp: 'hjo 12/29/2011 10:20'!
morphAbove
	^ morphAbove! !

!AbstractStackMorph methodsFor: 'accessing' stamp: 'hjo 12/29/2011 10:20'!
morphAbove: anObject
	morphAbove := anObject! !

!AbstractStackMorph methodsFor: 'accessing' stamp: 'hjo 12/29/2011 10:20'!
numberOfMorphsSittingOnMe

	morphAbove isNil ifTrue: [^0].
	^morphAbove numberOfMorphsSittingOnMe + 1! !

!AbstractStackMorph methodsFor: 'accessing' stamp: 'hjo 12/29/2011 10:20'!
sitOffset

	^(0@ -40) / self numberOfMorphsSittingOnMe! !

!AbstractStackMorph methodsFor: 'accessing' stamp: 'hjo 12/29/2011 10:20'!
stepTime

	^17! !

!AbstractStackMorph methodsFor: 'accessing' stamp: 'hjo 12/29/2011 10:20'!
topMorph

	morphAbove isNil ifTrue: [^self].
	^morphAbove topMorph! !

AbstractStackMorph subclass: #StackBaseMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ani-Demo-Stack'!

!StackBaseMorph classSide methodsFor: 'examples' stamp: 'hjo 12/29/2011 10:46'!
example

| b |
"create base"
b := StackBaseMorph new.
b openInWorld.

"place the base morph"
b center: Point fromUser. 

"add / remove stack"
b topMorph makeNewOneThatSitsOnMe.
b topMorph beRemovedFromStack.

"clean up"
b deleteStack.! !

!StackBaseMorph classSide methodsFor: 'examples' stamp: 'hjo 1/11/2012 11:04'!
rgbCategorizer

|uncategorized reds greens blues grays dest categorize|

"create base"
uncategorized := StackBaseMorph new.
uncategorized openInWorld.
uncategorized color: Color black.
uncategorized center: 569@495.

reds := StackBaseMorph new.
reds openInWorld.
reds color: Color red.
reds center: 370@284.

greens := StackBaseMorph new.
greens openInWorld.
greens color: Color green.
greens center:   356@716.

blues := StackBaseMorph new.
blues openInWorld.
blues color: Color blue.
blues center:  786@718.

grays := StackBaseMorph new.
grays openInWorld.
grays color: Color gray.
grays center:  771@289.


"add stack"
20 timesRepeat: [uncategorized topMorph makeNewOneThatSitsOnMe].

"define categories"
categorize := [ | c |
	uncategorized numberOfMorphsSittingOnMe > 0 ifTrue: [
c := uncategorized topMorph color.
(c saturation <0.342 or: [c brightness <  0.375])
	ifTrue: [ 
		dest := grays ]
	ifFalse: [ 
		(c hue between: 180 and:  300)
			ifTrue: [dest := blues ].
		(c hue between: 60 and:  180)
			ifTrue: [ dest := greens ].
		(c hue between: 0 and:  60)
			ifTrue: [dest :=  reds ].
		(c hue between: 300 and:  360)
			ifTrue: [dest :=  reds ].
		 ].
	uncategorized topMorph sitOn: dest topMorph.]
].
categorize value.
	

"clean up"
uncategorized deleteStack.
reds deleteStack.
greens deleteStack.
blues deleteStack.
grays deleteStack.


"remove plate one by one"
reds topMorph beRemovedFromStack.
greens topMorph beRemovedFromStack.
blues topMorph beRemovedFromStack.
grays topMorph beRemovedFromStack.
! !

!StackBaseMorph classSide methodsFor: 'examples' stamp: 'hjo 12/29/2011 18:42'!
tossStackingDocuments

|b1 b2|
"create base"
b1 := StackBaseMorph new.
b1 openInWorld.

b2 := StackBaseMorph new.
b2 openInWorld.


"place the base morph"
b1 center: Point fromUser. 
b2 center: Point fromUser. 

"add / remove stack"
b1 topMorph makeNewOneThatSitsOnMe.
b1 topMorph beRemovedFromStack.

b1 topMorph sitOn: b2 topMorph.
b2 topMorph sitOn: b1 topMorph.

"clean up"
b1 deleteStack.
b2 deleteStack.! !

!StackBaseMorph methodsFor: 'as yet unclassified' stamp: 'hjo 12/28/2011 19:49'!
beRemovedFromStack

	"sorry i cannot be removed"! !

!StackBaseMorph methodsFor: 'as yet unclassified' stamp: 'hjo 12/28/2011 19:52'!
deleteStack

	[self numberOfMorphsSittingOnMe > 0] whileTrue: [ self topMorph beRemovedFromStack ].
	self delete.! !

!StackBaseMorph methodsFor: 'as yet unclassified' stamp: 'hjo 12/28/2011 19:23'!
step! !

AbstractStackMorph subclass: #StackingMorph
	instanceVariableNames: 'morphBelow ani'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ani-Demo-Stack'!

!StackingMorph methodsFor: 'accessing' stamp: 'hjo 12/29/2011 10:33'!
ani

	^ani setDefault: #defaultAni for: self withSetter: #ani:! !

!StackingMorph methodsFor: 'accessing' stamp: 'hjo 12/29/2011 10:33'!
ani: anObject
		
	ani := anObject! !

!StackingMorph methodsFor: 'as yet unclassified' stamp: 'hjo 12/28/2011 19:48'!
beRemovedFromStack

	morphBelow morphAbove: nil.
	self morphBelow: nil.    
	self delete.! !

!StackingMorph methodsFor: 'defaults' stamp: 'hjo 1/13/2012 20:40'!
defaultAni

	"Return a default object for instance variable ani."
	| a |
	a := InertialEnvyAni new.
	a inertia: 0@0.  
	a friction: 0.2.
	a stiffness: 0.2.
	a targetEvaluator: [morphBelow center + morphBelow sitOffset].
	a currentEvaluator: [self center].
	a operation: [:p| self center: p].  
	^a! !

!StackingMorph methodsFor: 'accessing' stamp: 'hjo 12/28/2011 19:22'!
morphBelow
	^ morphBelow! !

!StackingMorph methodsFor: 'accessing' stamp: 'hjo 12/28/2011 19:22'!
morphBelow: anObject
	morphBelow := anObject! !

!StackingMorph methodsFor: 'as yet unclassified' stamp: 'hjo 12/29/2011 11:05'!
sitOn: aBaseMorph 

	aBaseMorph morphAbove: self.
	self morphBelow notNil ifTrue: [self morphBelow morphAbove: nil].
	self morphBelow: aBaseMorph  ! !

!StackingMorph methodsFor: 'accessing' stamp: 'hjo 12/29/2011 10:39'!
step

	morphBelow isNil ifFalse: [
		self ani step.
		owner addMorph: self inFrontOf: morphBelow.
		]
	! !

!StackingMorph methodsFor: 'accessing' stamp: 'hjo 12/29/2011 10:35'!
stepTime

	^self ani stepTime
	! !

Morph subclass: #Ameba
	instanceVariableNames: 'ani'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ani-Demo-Ameba'!

!Ameba classSide methodsFor: 'examples' stamp: 'hjo 1/11/2012 11:26'!
example 

|c a n|
c := {Color red. Color green. Color blue. Color magenta. Color black. Color brown. Color cyan. Color darkGray} readStream.
a := OrderedCollection new.

n := Ameba new.
n color: c next. 
a add: n.

[c atEnd] whileFalse: [
	n := FollowingAmeba new.
	n color: c next. 
	n ahead: a last.
	a add: n.
].

a do: [:each| each openInWorld].
a do: [:each| each goBehind].
a do: [:each| each startStepping].


a reverseDo: [:each| each delete].
a do: [:each| each stopStepping].! !

!Ameba methodsFor: 'accessing' stamp: 'hjo 1/4/2012 16:54'!
ani

	^ani setDefault: #defaultAni for: self withSetter: #ani:! !

!Ameba methodsFor: 'accessing' stamp: 'hjo 1/4/2012 16:54'!
ani: anObject
		
	ani := anObject! !

!Ameba methodsFor: 'submorphs-add/remove' stamp: 'hjo 1/4/2012 17:20'!
chainDelete

	"This method is terribly slow. Don't use it. :) "
	| objectsPointingMe amebaFollowingMe |
	objectsPointingMe := self pointersTo.
	amebaFollowingMe := objectsPointingMe select: [:each| each respondsTo: #ahead: ].
	self stopStepping.
	self delete.
	amebaFollowingMe do: [:each| each chainDelete ]! !

!Ameba methodsFor: 'defaults' stamp: 'hjo 1/4/2012 17:06'!
defaultAni

	"Return a default object for instance variable ani."
	^InertialEnvyAni new
		targetEvaluator: [ Sensor cursorPoint ];
		currentEvaluator: [ self center ];
		operation: [:v| self center: v ]    ! !

!Ameba methodsFor: 'event handling' stamp: 'hjo 1/18/2009 23:51'!
handlesMouseDown: anEvent

	^true! !

!Ameba methodsFor: 'event handling' stamp: 'hjo 1/4/2012 17:00'!
mouseDown: anEvent

	self ani toggleStepping! !

!Ameba methodsFor: 'stepping and presenter' stamp: 'hjo 1/4/2012 16:55'!
startStepping 

	self ani startStepping! !

!Ameba methodsFor: 'stepping and presenter' stamp: 'hjo 1/4/2012 16:55'!
stopStepping  

	self ani stopStepping! !

Ameba subclass: #FollowingAmeba
	instanceVariableNames: 'ahead'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ani-Demo-Ameba'!

!FollowingAmeba methodsFor: 'accessing' stamp: 'hjo 1/19/2009 00:05'!
ahead

	^ahead! !

!FollowingAmeba methodsFor: 'accessing' stamp: 'hjo 1/19/2009 00:05'!
ahead: anAmeba

	ahead := anAmeba! !

!FollowingAmeba methodsFor: 'defaults' stamp: 'hjo 1/4/2012 17:07'!
defaultAni

	"Return a default object for instance variable ani."
	^super defaultAni
		targetEvaluator: [ self ahead center ]! !

CircleMorph subclass: #HeavenlyBodyMorph
	instanceVariableNames: 'apsis orbitCenterMorph angularVelocity angle'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ani-Demo-SolarSystem'!

!HeavenlyBodyMorph methodsFor: 'accessing' stamp: 'hjo 1/1/2012 20:38'!
angle

	^angle setDefault: #defaultAngle for: self withSetter: #angle:! !

!HeavenlyBodyMorph methodsFor: 'accessing' stamp: 'hjo 1/1/2012 21:01'!
angle: aNumber
		
	angle := aNumber rem: 360! !

!HeavenlyBodyMorph methodsFor: 'accessing' stamp: 'hjo 1/1/2012 17:23'!
angularVelocity

	^angularVelocity setDefault: #defaultAngularVelocity for: self withSetter: #angularVelocity:! !

!HeavenlyBodyMorph methodsFor: 'accessing' stamp: 'hjo 1/1/2012 17:23'!
angularVelocity: anObject
		
	angularVelocity := anObject! !

!HeavenlyBodyMorph methodsFor: 'accessing' stamp: 'hjo 1/1/2012 17:19'!
apsis

	^apsis setDefault: #defaultApsis for: self withSetter: #apsis:! !

!HeavenlyBodyMorph methodsFor: 'accessing' stamp: 'hjo 1/1/2012 17:19'!
apsis: anObject
		
	apsis := anObject! !

!HeavenlyBodyMorph methodsFor: 'defaults' stamp: 'hjo 1/1/2012 20:38'!
defaultAngle

	"Return a default object for instance variable angle."
	^0! !

!HeavenlyBodyMorph methodsFor: 'defaults' stamp: 'hjo 1/1/2012 17:23'!
defaultAngularVelocity

	"Return a default object for instance variable angularVelocity."
	^2! !

!HeavenlyBodyMorph methodsFor: 'defaults' stamp: 'hjo 1/1/2012 17:19'!
defaultApsis

	"Return a default object for instance variable apsis."
	^40! !

!HeavenlyBodyMorph methodsFor: 'defaults' stamp: 'hjo 1/1/2012 17:19'!
defaultOrbitCenterMorph

	"Return a default object for instance variable orbitCenterMorph."
	^World! !

!HeavenlyBodyMorph methodsFor: 'as yet unclassified' stamp: 'hjo 1/1/2012 18:04'!
delete

	self stopStepping.
	super delete.! !

!HeavenlyBodyMorph methodsFor: 'as yet unclassified' stamp: 'hjo 1/1/2012 20:39'!
followOrbit

	self angle: self angle + self angularVelocity.
	self center: (Point r: self apsis degrees:  self angle) + self orbitCenterMorph center.
! !

!HeavenlyBodyMorph methodsFor: 'accessing' stamp: 'hjo 1/1/2012 17:19'!
orbitCenterMorph

	^orbitCenterMorph setDefault: #defaultOrbitCenterMorph for: self withSetter: #orbitCenterMorph:! !

!HeavenlyBodyMorph methodsFor: 'accessing' stamp: 'hjo 1/1/2012 17:19'!
orbitCenterMorph: anObject
		
	orbitCenterMorph := anObject! !
